######################
# ONI TEAM ARENA 1.0 #
######################
# arena_rand.bsl for tctf_ii
###############################

################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag= 0; var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 22; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag_max= 38;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 3;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	sleep 400; now_playing= next_tune; sound_music_start(now_playing);
	sleep 6000; sound_music_stop(now_playing); fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 3; ArenaResetFlags();

	now_playing= mus_xtr1; next_tune= mus_xtr1;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) rand_flag_max= 21;
	if(arena_area eq 1) rand_flag_max= 14;
	if(arena_area eq 2) rand_flag_max= 10;
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag= rand_flag + 1; if(rand_flag > rand_flag_max) rand_flag= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_xtr1;
	if(rand_music eq 1) next_tune= mus_space01;
	if(rand_music eq 2) next_tune= mus_low1;
	if(rand_music eq 3) next_tune= mus_sad1;
	if(next_tune eq now_playing and now_playing ne mus_xtr1) next_tune= mus_xtr1;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(string ai_name, string ai_team) {
	if(arena_area eq 0) {
################ TSP: Pods
		if(rand_flag eq  0)
			{chr_teleport(ai_name,   103); chr_facetoflag(ai_name,   103);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   203); chr_facetoflag(ai_name,   203);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   207); chr_facetoflag(ai_name,   207);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   208); chr_facetoflag(ai_name,   208);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   210); chr_facetoflag(ai_name,   210);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   211); chr_facetoflag(ai_name,   211);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   212); chr_facetoflag(ai_name,   212);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   214); chr_facetoflag(ai_name,   214);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   231); chr_facetoflag(ai_name,   231);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   233); chr_facetoflag(ai_name,   233);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   235); chr_facetoflag(ai_name,   235);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   237); chr_facetoflag(ai_name,   237);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   239); chr_facetoflag(ai_name,   239);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,   241); chr_facetoflag(ai_name,   241);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,   243); chr_facetoflag(ai_name,   243);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,   245); chr_facetoflag(ai_name,   245);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,   247); chr_facetoflag(ai_name,   247);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,   249); chr_facetoflag(ai_name,   249);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,   251); chr_facetoflag(ai_name,   251);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,   253); chr_facetoflag(ai_name,   253);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name,   257); chr_facetoflag(ai_name,   257);}
		if(rand_flag > 20)
			{chr_teleport(ai_name,   259); chr_facetoflag(ai_name,   259);}
	}
	if(arena_area eq 1) {
################ ACIDIC
		if(rand_flag eq  0)
			{chr_teleport(ai_name, 220); chr_facetoflag(ai_name, 220);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name, 221); chr_facetoflag(ai_name, 221);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name, 222); chr_facetoflag(ai_name, 222);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name, 223); chr_facetoflag(ai_name, 223);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name, 224); chr_facetoflag(ai_name, 224);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name, 225); chr_facetoflag(ai_name, 225);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name, 306); chr_facetoflag(ai_name, 306);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name, 354); chr_facetoflag(ai_name, 354);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name, 355); chr_facetoflag(ai_name, 355);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name, 356); chr_facetoflag(ai_name, 356);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name, 357); chr_facetoflag(ai_name, 357);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name, 7002); chr_facetoflag(ai_name, 7002);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name, 7010); chr_facetoflag(ai_name, 7010);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name, 7016); chr_facetoflag(ai_name, 7016);}
		if(rand_flag >  13)
			{chr_teleport(ai_name, 7017); chr_facetoflag(ai_name, 7017);}
}
	if(arena_area eq 2) {
################ SCANNER
		if(rand_flag eq  0)
			{chr_teleport(ai_name,   100); chr_facetoflag(ai_name,   100);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   101); chr_facetoflag(ai_name,   101);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   112); chr_facetoflag(ai_name,   112);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   113); chr_facetoflag(ai_name,   113);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   230); chr_facetoflag(ai_name,   230);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   304); chr_facetoflag(ai_name,   304);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   305); chr_facetoflag(ai_name,   305);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   7005); chr_facetoflag(ai_name,  7005);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   7006); chr_facetoflag(ai_name,  7006);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   7007); chr_facetoflag(ai_name,  7007);}
		if(rand_flag  >  9)
			{chr_teleport(ai_name,   7008); chr_facetoflag(ai_name,  7008);}
	}
	chr_animate(ai_name, NINCOMteleport_out);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "is dead"
}
